diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/decoders/unpack.cpp libkdcraw/libkdcraw/libraw/src/decoders/unpack.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/decoders/unpack.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/decoders/unpack.cpp	2022-11-07 07:46:31.730795008 +0300
@@ -0,0 +1,365 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+#include "../../internal/libraw_cameraids.h"
+#include "../../internal/libraw_cxx_defs.h"
+
+int LibRaw::unpack(void)
+{
+  CHECK_ORDER_HIGH(LIBRAW_PROGRESS_LOAD_RAW);
+  CHECK_ORDER_LOW(LIBRAW_PROGRESS_IDENTIFY);
+  try
+  {
+
+    if (!libraw_internal_data.internal_data.input)
+      return LIBRAW_INPUT_CLOSED;
+
+    RUN_CALLBACK(LIBRAW_PROGRESS_LOAD_RAW, 0, 2);
+    if (O.shot_select >= P1.raw_count)
+      return LIBRAW_REQUEST_FOR_NONEXISTENT_IMAGE;
+
+    if (!load_raw)
+      return LIBRAW_UNSPECIFIED_ERROR;
+
+    // already allocated ?
+    if (imgdata.image)
+    {
+      free(imgdata.image);
+      imgdata.image = 0;
+    }
+    if (imgdata.rawdata.raw_alloc)
+    {
+      free(imgdata.rawdata.raw_alloc);
+      imgdata.rawdata.raw_alloc = 0;
+    }
+    if (libraw_internal_data.unpacker_data.meta_length)
+    {
+      libraw_internal_data.internal_data.meta_data =
+          (char *)malloc(libraw_internal_data.unpacker_data.meta_length);
+      merror(libraw_internal_data.internal_data.meta_data, "LibRaw::unpack()");
+    }
+
+    libraw_decoder_info_t decoder_info;
+    get_decoder_info(&decoder_info);
+
+    int save_iwidth = S.iwidth, save_iheight = S.iheight,
+        save_shrink = IO.shrink;
+
+    int rwidth = S.raw_width, rheight = S.raw_height;
+    if (!IO.fuji_width)
+    {
+      // adjust non-Fuji allocation
+      if (rwidth < S.width + S.left_margin)
+        rwidth = S.width + S.left_margin;
+      if (rheight < S.height + S.top_margin)
+        rheight = S.height + S.top_margin;
+    }
+    if (rwidth > 65535 ||
+        rheight > 65535) // No way to make image larger than 64k pix
+      throw LIBRAW_EXCEPTION_IO_CORRUPT;
+
+    imgdata.rawdata.raw_image = 0;
+    imgdata.rawdata.color4_image = 0;
+    imgdata.rawdata.color3_image = 0;
+    imgdata.rawdata.float_image = 0;
+    imgdata.rawdata.float3_image = 0;
+
+#ifdef USE_DNGSDK
+    if (imgdata.idata.dng_version && dnghost
+        && libraw_internal_data.unpacker_data.tiff_samples != 2  // Fuji SuperCCD; it is better to detect is more rigid way
+        && valid_for_dngsdk() && load_raw != &LibRaw::pentax_4shot_load_raw)
+    {
+      // Data size check
+      INT64 pixcount =
+          INT64(MAX(S.width, S.raw_width)) * INT64(MAX(S.height, S.raw_height));
+      INT64 planecount =
+          (imgdata.idata.filters || P1.colors == 1) ? 1 : LIM(P1.colors, 3, 4);
+      INT64 samplesize = is_floating_point() ? 4 : 2;
+      INT64 bytes = pixcount * planecount * samplesize;
+      if (bytes > INT64(imgdata.params.max_raw_memory_mb) * INT64(1024 * 1024))
+        throw LIBRAW_EXCEPTION_TOOBIG;
+
+      // find ifd to check sample
+      int rr = try_dngsdk();
+      if (raw_was_read())
+        imgdata.process_warnings |= LIBRAW_WARN_DNGSDK_PROCESSED;
+    }
+#endif
+
+#ifdef USE_RAWSPEED
+    if (!raw_was_read())
+    {
+      int rawspeed_enabled = 1;
+
+      if (imgdata.idata.dng_version && (libraw_internal_data.unpacker_data.tiff_samples == 2 || imgdata.idata.raw_count > 1))
+        rawspeed_enabled = 0;
+
+      if (libraw_internal_data.unpacker_data.is_NikonTransfer)
+        rawspeed_enabled = 0;
+
+      if (libraw_internal_data.unpacker_data.pana_encoding == 5)
+        rawspeed_enabled = 0;
+
+      if (imgdata.idata.raw_count > 1)
+        rawspeed_enabled = 0;
+      if (!strncasecmp(imgdata.idata.software, "Magic", 5))
+        rawspeed_enabled = 0;
+      // Disable rawspeed for double-sized Oly files
+      if (makeIs(LIBRAW_CAMERAMAKER_Olympus) &&
+          ((imgdata.sizes.raw_width > 6000) ||
+           !strncasecmp(imgdata.idata.model, "SH-", 3) ||
+           !strncasecmp(imgdata.idata.model, "TG-", 3) ))
+        rawspeed_enabled = 0;
+
+      if (makeIs(LIBRAW_CAMERAMAKER_Canon) &&
+          (libraw_internal_data.identify_data.unique_id == CanonID_EOS_6D_Mark_II))
+        rawspeed_enabled = 0;
+
+      if (imgdata.idata.dng_version && imgdata.idata.filters == 0 &&
+          libraw_internal_data.unpacker_data.tiff_bps == 8) // Disable for 8 bit
+        rawspeed_enabled = 0;
+
+      if (load_raw == &LibRaw::packed_load_raw &&
+        makeIs(LIBRAW_CAMERAMAKER_Nikon) &&
+          (!strncasecmp(imgdata.idata.model, "E", 1) ||
+           !strncasecmp(imgdata.idata.model, "COOLPIX B", 9) ||
+		   !strncasecmp(imgdata.idata.model, "COOLPIX P9", 10) ||
+           !strncasecmp(imgdata.idata.model, "COOLPIX P1000", 13)))
+        rawspeed_enabled = 0;
+
+	if (load_raw == &LibRaw::lossless_jpeg_load_raw &&
+		imgdata.makernotes.canon.RecordMode && makeIs(LIBRAW_CAMERAMAKER_Kodak) &&
+		/* Not normalized models here, it is intentional */
+		(!strncasecmp(imgdata.idata.model, "EOS D2000", 9) ||
+		 !strncasecmp(imgdata.idata.model, "EOS D6000", 9)))
+	  rawspeed_enabled = 0;
+
+      if (load_raw == &LibRaw::nikon_load_raw &&
+        makeIs(LIBRAW_CAMERAMAKER_Nikon) &&
+          (!strncasecmp(imgdata.idata.model, "Z", 1) || !strncasecmp(imgdata.idata.model,"D780",4)))
+        rawspeed_enabled = 0;
+
+      if (load_raw == &LibRaw::panasonic_load_raw &&
+          libraw_internal_data.unpacker_data.pana_encoding > 4)
+        rawspeed_enabled = 0;
+
+      // RawSpeed Supported,
+      if (O.use_rawspeed && rawspeed_enabled &&
+          !(is_sraw() && (O.raw_processing_options &
+                          (LIBRAW_PROCESSING_SRAW_NO_RGB |
+                           LIBRAW_PROCESSING_SRAW_NO_INTERPOLATE))) &&
+          (decoder_info.decoder_flags & LIBRAW_DECODER_TRYRAWSPEED) &&
+          _rawspeed_camerameta)
+      {
+        INT64 pixcount = INT64(MAX(S.width, S.raw_width)) *
+                         INT64(MAX(S.height, S.raw_height));
+        INT64 planecount = (imgdata.idata.filters || P1.colors == 1)
+                               ? 1
+                               : LIM(P1.colors, 3, 4);
+        INT64 bytes =
+            pixcount * planecount * 2; // sample size is always 2 for rawspeed
+        if (bytes >
+            INT64(imgdata.params.max_raw_memory_mb) * INT64(1024 * 1024))
+          throw LIBRAW_EXCEPTION_TOOBIG;
+
+        int rr = try_rawspeed();
+      }
+    }
+#endif
+    if (!raw_was_read()) // RawSpeed failed or not run
+    {
+      // Not allocated on RawSpeed call, try call LibRaow
+      int zero_rawimage = 0;
+      if (decoder_info.decoder_flags & LIBRAW_DECODER_OWNALLOC)
+      {
+        // x3f foveon decoder and DNG float
+        // Do nothing! Decoder will allocate data internally
+      }
+      if (decoder_info.decoder_flags & LIBRAW_DECODER_SINAR4SHOT)
+      {
+        if (imgdata.params.shot_select) // single image extract
+        {
+          if (INT64(rwidth) * INT64(rheight + 8) *
+                  sizeof(imgdata.rawdata.raw_image[0]) >
+              INT64(imgdata.params.max_raw_memory_mb) * INT64(1024 * 1024))
+            throw LIBRAW_EXCEPTION_TOOBIG;
+          imgdata.rawdata.raw_alloc = malloc(
+              rwidth * (rheight + 8) * sizeof(imgdata.rawdata.raw_image[0]));
+          imgdata.rawdata.raw_image = (ushort *)imgdata.rawdata.raw_alloc;
+          if (!S.raw_pitch)
+            S.raw_pitch = S.raw_width * 2; // Bayer case, not set before
+        }
+        else // Full image extract
+        {
+          if (INT64(rwidth) * INT64(rheight + 8) *
+                  sizeof(imgdata.rawdata.raw_image[0]) * 4 >
+              INT64(imgdata.params.max_raw_memory_mb) * INT64(1024 * 1024))
+            throw LIBRAW_EXCEPTION_TOOBIG;
+          S.raw_pitch = S.raw_width * 8;
+          imgdata.rawdata.raw_alloc = 0;
+          imgdata.image = (ushort(*)[4])calloc(
+              unsigned(MAX(S.width, S.raw_width)) *
+                  unsigned(MAX(S.height, S.raw_height) + 8),
+              sizeof(*imgdata.image));
+        }
+      }
+      else if (decoder_info.decoder_flags & LIBRAW_DECODER_3CHANNEL)
+      {
+        if (INT64(rwidth) * INT64(rheight + 8) *
+                sizeof(imgdata.rawdata.raw_image[0]) * 3 >
+            INT64(imgdata.params.max_raw_memory_mb) * INT64(1024 * 1024))
+          throw LIBRAW_EXCEPTION_TOOBIG;
+
+        imgdata.rawdata.raw_alloc = malloc(
+            rwidth * (rheight + 8) * sizeof(imgdata.rawdata.raw_image[0]) * 3);
+        imgdata.rawdata.color3_image = (ushort(*)[3])imgdata.rawdata.raw_alloc;
+        if (!S.raw_pitch)
+          S.raw_pitch = S.raw_width * 6;
+      }
+      else if (imgdata.idata.filters ||
+               P1.colors ==
+                   1) // Bayer image or single color -> decode to raw_image
+      {
+        if (INT64(rwidth) * INT64(rheight + 8) *
+                sizeof(imgdata.rawdata.raw_image[0]) >
+            INT64(imgdata.params.max_raw_memory_mb) * INT64(1024 * 1024))
+          throw LIBRAW_EXCEPTION_TOOBIG;
+        imgdata.rawdata.raw_alloc = malloc(
+            rwidth * (rheight + 8) * sizeof(imgdata.rawdata.raw_image[0]));
+        imgdata.rawdata.raw_image = (ushort *)imgdata.rawdata.raw_alloc;
+        if (!S.raw_pitch)
+          S.raw_pitch = S.raw_width * 2; // Bayer case, not set before
+      }
+      else // NO LEGACY FLAG if (decoder_info.decoder_flags &
+           // LIBRAW_DECODER_LEGACY)
+      {
+        if (decoder_info.decoder_flags & LIBRAW_DECODER_ADOBECOPYPIXEL)
+        {
+          S.raw_pitch = S.raw_width * 8;
+        }
+        else
+        {
+          S.iwidth = S.width;
+          S.iheight = S.height;
+          IO.shrink = 0;
+          if (!S.raw_pitch)
+            S.raw_pitch = (decoder_info.decoder_flags &
+                           LIBRAW_DECODER_LEGACY_WITH_MARGINS)
+                              ? S.raw_width * 8
+                              : S.width * 8;
+        }
+        // sRAW and old Foveon decoders only, so extra buffer size is just 1/4
+        // allocate image as temporary buffer, size
+        if (INT64(MAX(S.width, S.raw_width)) *
+                INT64(MAX(S.height, S.raw_height) + 8) *
+                sizeof(*imgdata.image) >
+            INT64(imgdata.params.max_raw_memory_mb) * INT64(1024 * 1024))
+          throw LIBRAW_EXCEPTION_TOOBIG;
+
+        imgdata.rawdata.raw_alloc = 0;
+        imgdata.image =
+            (ushort(*)[4])calloc(unsigned(MAX(S.width, S.raw_width)) *
+                                     unsigned(MAX(S.height, S.raw_height) + 8),
+                                 sizeof(*imgdata.image));
+        if (!(decoder_info.decoder_flags & LIBRAW_DECODER_ADOBECOPYPIXEL))
+        {
+          imgdata.rawdata.raw_image = (ushort *)imgdata.image;
+          zero_rawimage = 1;
+        }
+      }
+      ID.input->seek(libraw_internal_data.unpacker_data.data_offset, SEEK_SET);
+
+      unsigned m_save = C.maximum;
+      if (load_raw == &LibRaw::unpacked_load_raw &&
+          (!strcasecmp(imgdata.idata.make, "Nikon") || !strcasecmp(imgdata.idata.make, "Hasselblad"))
+          )
+        C.maximum = 65535;
+      (this->*load_raw)();
+      if (zero_rawimage)
+        imgdata.rawdata.raw_image = 0;
+      if (load_raw == &LibRaw::unpacked_load_raw &&
+          (!strcasecmp(imgdata.idata.make, "Nikon") || !strcasecmp(imgdata.idata.make, "Hasselblad"))
+          )
+        C.maximum = m_save;
+      if (decoder_info.decoder_flags & LIBRAW_DECODER_OWNALLOC)
+      {
+        // x3f foveon decoder only: do nothing
+      }
+      else if (decoder_info.decoder_flags & LIBRAW_DECODER_SINAR4SHOT &&
+               imgdata.params.shot_select == 0)
+      {
+        imgdata.rawdata.raw_alloc = imgdata.image;
+        imgdata.rawdata.color4_image = (ushort(*)[4])imgdata.rawdata.raw_alloc;
+        imgdata.image = 0;
+      }
+      else if (!(imgdata.idata.filters ||
+                 P1.colors == 1)) // legacy decoder, ownalloc handled above
+      {
+        // successfully decoded legacy image, attach image to raw_alloc
+        imgdata.rawdata.raw_alloc = imgdata.image;
+        imgdata.rawdata.color4_image = (ushort(*)[4])imgdata.rawdata.raw_alloc;
+        imgdata.image = 0;
+        // Restore saved values. Note: Foveon have masked frame
+        // Other 4-color legacy data: no borders
+        if (!(libraw_internal_data.unpacker_data.load_flags & 256) &&
+            !(decoder_info.decoder_flags & LIBRAW_DECODER_ADOBECOPYPIXEL) &&
+            !(decoder_info.decoder_flags & LIBRAW_DECODER_LEGACY_WITH_MARGINS))
+        {
+          S.raw_width = S.width;
+          S.left_margin = 0;
+          S.raw_height = S.height;
+          S.top_margin = 0;
+        }
+      }
+    }
+
+    if (imgdata.rawdata.raw_image)
+      crop_masked_pixels(); // calculate black levels
+
+    // recover image sizes
+    S.iwidth = save_iwidth;
+    S.iheight = save_iheight;
+    IO.shrink = save_shrink;
+
+    // adjust black to possible maximum
+    unsigned int i = C.cblack[3];
+    unsigned int c;
+    for (c = 0; c < 3; c++)
+      if (i > C.cblack[c])
+        i = C.cblack[c];
+    for (c = 0; c < 4; c++)
+      C.cblack[c] -= i;
+    C.black += i;
+
+    // Save color,sizes and internal data into raw_image fields
+    memmove(&imgdata.rawdata.color, &imgdata.color, sizeof(imgdata.color));
+    memmove(&imgdata.rawdata.sizes, &imgdata.sizes, sizeof(imgdata.sizes));
+    memmove(&imgdata.rawdata.iparams, &imgdata.idata, sizeof(imgdata.idata));
+    memmove(&imgdata.rawdata.ioparams,
+            &libraw_internal_data.internal_output_params,
+            sizeof(libraw_internal_data.internal_output_params));
+
+    SET_PROC_FLAG(LIBRAW_PROGRESS_LOAD_RAW);
+    RUN_CALLBACK(LIBRAW_PROGRESS_LOAD_RAW, 1, 2);
+
+    return 0;
+  }
+  catch (const LibRaw_exceptions& err)
+  {
+    EXCEPTION_HANDLER(err);
+  }
+  catch (const std::exception& ee)
+  {
+    EXCEPTION_HANDLER(LIBRAW_EXCEPTION_IO_CORRUPT);
+  }
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/decoders/unpack_thumb.cpp libkdcraw/libkdcraw/libraw/src/decoders/unpack_thumb.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/decoders/unpack_thumb.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/decoders/unpack_thumb.cpp	2022-11-07 07:46:31.730795008 +0300
@@ -0,0 +1,360 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/libraw_cxx_defs.h"
+
+#ifndef NO_JPEG
+struct jpegErrorManager
+{
+  struct jpeg_error_mgr pub;
+  jmp_buf setjmp_buffer;
+};
+
+static void jpegErrorExit(j_common_ptr cinfo)
+{
+  jpegErrorManager *myerr = (jpegErrorManager *)cinfo->err;
+  longjmp(myerr->setjmp_buffer, 1);
+}
+#endif
+
+int LibRaw::unpack_thumb(void)
+{
+  CHECK_ORDER_LOW(LIBRAW_PROGRESS_IDENTIFY);
+  CHECK_ORDER_BIT(LIBRAW_PROGRESS_THUMB_LOAD);
+
+#define THUMB_SIZE_CHECKT(A) \
+  do { \
+    if (INT64(A) > 1024ULL * 1024ULL * LIBRAW_MAX_THUMBNAIL_MB) throw LIBRAW_EXCEPTION_IO_CORRUPT; \
+    if (INT64(A) > 0 &&  INT64(A) < 64ULL)        throw LIBRAW_EXCEPTION_IO_CORRUPT; \
+  } while (0)
+
+#define THUMB_SIZE_CHECKTNZ(A) \
+  do { \
+    if (INT64(A) > 1024ULL * 1024ULL * LIBRAW_MAX_THUMBNAIL_MB) throw LIBRAW_EXCEPTION_IO_CORRUPT; \
+    if (INT64(A) < 64ULL)        throw LIBRAW_EXCEPTION_IO_CORRUPT; \
+  } while (0)
+
+
+#define THUMB_SIZE_CHECKWH(W,H) \
+  do { \
+    if (INT64(W)*INT64(H) > 1024ULL * 1024ULL * LIBRAW_MAX_THUMBNAIL_MB) throw LIBRAW_EXCEPTION_IO_CORRUPT; \
+    if (INT64(W)*INT64(H) < 64ULL)        throw LIBRAW_EXCEPTION_IO_CORRUPT; \
+  } while (0)
+
+  try
+  {
+    if (!libraw_internal_data.internal_data.input)
+      return LIBRAW_INPUT_CLOSED;
+
+    int t_colors = libraw_internal_data.unpacker_data.thumb_misc >> 5 & 7;
+    int t_bytesps = (libraw_internal_data.unpacker_data.thumb_misc & 31) / 8;
+
+    if (!ID.toffset && !(imgdata.thumbnail.tlength > 0 &&
+                         load_raw == &LibRaw::broadcom_load_raw) // RPi
+    )
+    {
+      return LIBRAW_NO_THUMBNAIL;
+    }
+    else if (thumb_load_raw)
+    {
+      kodak_thumb_loader();
+      T.tformat = LIBRAW_THUMBNAIL_BITMAP;
+      SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+      return 0;
+    }
+    else
+    {
+#ifdef USE_X3FTOOLS
+	if (write_thumb == &LibRaw::x3f_thumb_loader)
+      {
+        INT64 tsize = x3f_thumb_size();
+        if (tsize < 2048 || INT64(ID.toffset) + tsize < 1)
+          throw LIBRAW_EXCEPTION_IO_CORRUPT;
+
+        if (INT64(ID.toffset) + tsize > ID.input->size() + THUMB_READ_BEYOND)
+          throw LIBRAW_EXCEPTION_IO_EOF;
+        THUMB_SIZE_CHECKT(tsize);
+      }
+#else
+	if (0) {}
+#endif
+      else
+      {
+        if (INT64(ID.toffset) + INT64(T.tlength) < 1)
+          throw LIBRAW_EXCEPTION_IO_CORRUPT;
+
+        if (INT64(ID.toffset) + INT64(T.tlength) >
+            ID.input->size() + THUMB_READ_BEYOND)
+          throw LIBRAW_EXCEPTION_IO_EOF;
+      }
+
+      ID.input->seek(ID.toffset, SEEK_SET);
+      if (write_thumb == &LibRaw::jpeg_thumb)
+      {
+        THUMB_SIZE_CHECKTNZ(T.tlength);
+
+        if (T.thumb)
+          free(T.thumb);
+        T.thumb = (char *)malloc(T.tlength);
+        merror(T.thumb, "jpeg_thumb()");
+        ID.input->read(T.thumb, 1, T.tlength);
+        unsigned char *tthumb = (unsigned char *)T.thumb;
+        tthumb[0] = 0xff;
+        tthumb[1] = 0xd8;
+#ifdef NO_JPEG
+        T.tcolors = 3;
+#else
+        {
+          jpegErrorManager jerr;
+          struct jpeg_decompress_struct cinfo;
+          cinfo.err = jpeg_std_error(&jerr.pub);
+          jerr.pub.error_exit = jpegErrorExit;
+          if (setjmp(jerr.setjmp_buffer))
+          {
+          err2:
+            // Error in original JPEG thumb, read it again because
+            // original bytes 0-1 was damaged above
+            jpeg_destroy_decompress(&cinfo);
+            T.tcolors = 3;
+            T.tformat = LIBRAW_THUMBNAIL_UNKNOWN;
+            ID.input->seek(ID.toffset, SEEK_SET);
+            ID.input->read(T.thumb, 1, T.tlength);
+            SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+            return 0;
+          }
+          jpeg_create_decompress(&cinfo);
+          jpeg_mem_src(&cinfo, (unsigned char *)T.thumb, T.tlength);
+          int rc = jpeg_read_header(&cinfo, TRUE);
+          if (rc != 1)
+            goto err2;
+          T.tcolors = (cinfo.num_components > 0 && cinfo.num_components <= 3)
+                          ? cinfo.num_components
+                          : 3;
+          jpeg_destroy_decompress(&cinfo);
+        }
+#endif
+        T.tformat = LIBRAW_THUMBNAIL_JPEG;
+        SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+        return 0;
+      }
+      else if (write_thumb == &LibRaw::layer_thumb)
+      {
+        int colors = libraw_internal_data.unpacker_data.thumb_misc >> 5 & 7;
+        if (colors != 1 && colors != 3)
+          return LIBRAW_UNSUPPORTED_THUMBNAIL;
+
+        THUMB_SIZE_CHECKWH(T.twidth, T.theight);
+
+        int tlength = T.twidth * T.theight;
+        if (T.thumb)
+          free(T.thumb);
+        T.thumb = (char *)calloc(colors, tlength);
+        merror(T.thumb, "layer_thumb()");
+        unsigned char *tbuf = (unsigned char *)calloc(colors, tlength);
+        merror(tbuf, "layer_thumb()");
+        ID.input->read(tbuf, colors, T.tlength);
+        if (libraw_internal_data.unpacker_data.thumb_misc >> 8 &&
+            colors == 3) // GRB order
+          for (int i = 0; i < tlength; i++)
+          {
+            T.thumb[i * 3] = tbuf[i + tlength];
+            T.thumb[i * 3 + 1] = tbuf[i];
+            T.thumb[i * 3 + 2] = tbuf[i + 2 * tlength];
+          }
+        else if (colors == 3) // RGB or 1-channel
+          for (int i = 0; i < tlength; i++)
+          {
+            T.thumb[i * 3] = tbuf[i];
+            T.thumb[i * 3 + 1] = tbuf[i + tlength];
+            T.thumb[i * 3 + 2] = tbuf[i + 2 * tlength];
+          }
+        else if (colors == 1)
+        {
+          free(T.thumb);
+          T.thumb = (char *)tbuf;
+          tbuf = 0;
+        }
+        if (tbuf)
+          free(tbuf);
+        T.tcolors = colors;
+        T.tlength = colors * tlength;
+        T.tformat = LIBRAW_THUMBNAIL_BITMAP;
+        SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+        return 0;
+      }
+      else if (write_thumb == &LibRaw::rollei_thumb)
+      {
+        int i;
+        THUMB_SIZE_CHECKWH(T.twidth, T.theight);
+        int tlength = T.twidth * T.theight;
+        if (T.thumb)
+          free(T.thumb);
+        T.tcolors = 3;
+        T.thumb = (char *)calloc(T.tcolors, tlength);
+        merror(T.thumb, "layer_thumb()");
+        unsigned short *tbuf = (unsigned short *)calloc(2, tlength);
+        merror(tbuf, "layer_thumb()");
+        read_shorts(tbuf, tlength);
+        for (i = 0; i < tlength; i++)
+        {
+          T.thumb[i * 3] = (tbuf[i] << 3) & 0xff;
+          T.thumb[i * 3 + 1] = (tbuf[i] >> 5 << 2) & 0xff;
+          T.thumb[i * 3 + 2] = (tbuf[i] >> 11 << 3) & 0xff;
+        }
+        free(tbuf);
+        T.tlength = T.tcolors * tlength;
+        T.tformat = LIBRAW_THUMBNAIL_BITMAP;
+        SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+        return 0;
+      }
+      else if (write_thumb == &LibRaw::ppm_thumb)
+      {
+        if (t_bytesps > 1)
+          throw LIBRAW_EXCEPTION_IO_CORRUPT; // 8-bit thumb, but parsed for more
+                                             // bits
+        THUMB_SIZE_CHECKWH(T.twidth, T.theight);
+        int t_length = T.twidth * T.theight * t_colors;
+
+        if (T.tlength &&
+            (int)T.tlength < t_length) // try to find tiff ifd with needed offset
+        {
+          int pifd = find_ifd_by_offset(libraw_internal_data.internal_data.toffset);
+          if (pifd >= 0 && tiff_ifd[pifd].strip_offsets_count &&
+              tiff_ifd[pifd].strip_byte_counts_count)
+          {
+            // We found it, calculate final size
+            unsigned total_size = 0;
+            for (int i = 0; i < tiff_ifd[pifd].strip_byte_counts_count; i++)
+              total_size += tiff_ifd[pifd].strip_byte_counts[i];
+            if (total_size != (unsigned)t_length) // recalculate colors
+            {
+              if (total_size == T.twidth * T.tlength * 3)
+                T.tcolors = 3;
+              else if (total_size == T.twidth * T.tlength)
+                T.tcolors = 1;
+            }
+            T.tlength = total_size;
+            THUMB_SIZE_CHECKTNZ(T.tlength);
+            if (T.thumb)
+              free(T.thumb);
+            T.thumb = (char *)malloc(T.tlength);
+            merror(T.thumb, "ppm_thumb()");
+
+            char *dest = T.thumb;
+            INT64 pos = ID.input->tell();
+
+            for (int i = 0; i < tiff_ifd[pifd].strip_byte_counts_count &&
+                            i < tiff_ifd[pifd].strip_offsets_count;
+                 i++)
+            {
+              int remain = T.tlength;
+              int sz = tiff_ifd[pifd].strip_byte_counts[i];
+              int off = tiff_ifd[pifd].strip_offsets[i];
+              if (off >= 0 && off + sz <= ID.input->size() && sz <= remain)
+              {
+                ID.input->seek(off, SEEK_SET);
+                ID.input->read(dest, sz, 1);
+                remain -= sz;
+                dest += sz;
+              }
+            }
+            ID.input->seek(pos, SEEK_SET);
+            T.tformat = LIBRAW_THUMBNAIL_BITMAP;
+            SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+            return 0;
+          }
+        }
+
+        if (!T.tlength)
+          T.tlength = t_length;
+        if (T.thumb)
+          free(T.thumb);
+
+        THUMB_SIZE_CHECKTNZ(T.tlength);
+
+        T.thumb = (char *)malloc(T.tlength);
+        if (!T.tcolors)
+          T.tcolors = t_colors;
+        merror(T.thumb, "ppm_thumb()");
+
+        ID.input->read(T.thumb, 1, T.tlength);
+
+        T.tformat = LIBRAW_THUMBNAIL_BITMAP;
+        SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+        return 0;
+      }
+      else if (write_thumb == &LibRaw::ppm16_thumb)
+      {
+        if (t_bytesps > 2)
+          throw LIBRAW_EXCEPTION_IO_CORRUPT; // 16-bit thumb, but parsed for
+                                             // more bits
+        int o_bps = (imgdata.params.raw_processing_options &
+                     LIBRAW_PROCESSING_USE_PPM16_THUMBS)
+                        ? 2
+                        : 1;
+        int o_length = T.twidth * T.theight * t_colors * o_bps;
+        int i_length = T.twidth * T.theight * t_colors * 2;
+        if (!T.tlength)
+          T.tlength = o_length;
+        THUMB_SIZE_CHECKTNZ(o_length);
+        THUMB_SIZE_CHECKTNZ(i_length);
+        THUMB_SIZE_CHECKTNZ(T.tlength);
+
+        ushort *t_thumb = (ushort *)calloc(i_length, 1);
+        ID.input->read(t_thumb, 1, i_length);
+        if ((libraw_internal_data.unpacker_data.order == 0x4949) ==
+            (ntohs(0x1234) == 0x1234))
+          swab((char *)t_thumb, (char *)t_thumb, i_length);
+
+        if (T.thumb)
+          free(T.thumb);
+        if ((imgdata.params.raw_processing_options &
+             LIBRAW_PROCESSING_USE_PPM16_THUMBS))
+        {
+          T.thumb = (char *)t_thumb;
+          T.tformat = LIBRAW_THUMBNAIL_BITMAP16;
+        }
+        else
+        {
+          T.thumb = (char *)malloc(o_length);
+          merror(T.thumb, "ppm_thumb()");
+          for (int i = 0; i < o_length; i++)
+            T.thumb[i] = t_thumb[i] >> 8;
+          free(t_thumb);
+          T.tformat = LIBRAW_THUMBNAIL_BITMAP;
+        }
+        SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+        return 0;
+      }
+#ifdef USE_X3FTOOLS
+	  else if (write_thumb == &LibRaw::x3f_thumb_loader)
+      {
+        x3f_thumb_loader();
+        SET_PROC_FLAG(LIBRAW_PROGRESS_THUMB_LOAD);
+        return 0;
+      }
+#endif
+      else
+      {
+        return LIBRAW_UNSUPPORTED_THUMBNAIL;
+      }
+    }
+    // last resort
+    return LIBRAW_UNSUPPORTED_THUMBNAIL;
+  }
+  catch (LibRaw_exceptions err)
+  {
+    EXCEPTION_HANDLER(err);
+  }
+}
